<?php
/**
*
* @author Shredder
* @version $Id$
* @copyright (c) 2013 www.phpbb-work.ru
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
define('UMIL_AUTO', true);
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);

include($phpbb_root_path . 'common.' . $phpEx);
$user->session_begin();
$auth->acl($user->data);
$user->setup();

if (!file_exists($phpbb_root_path . 'umil/umil_auto.' . $phpEx))
{
	trigger_error('Please download the latest UMIL (Unified MOD Install Library) from: <a href="http://www.phpbb.com/mods/umil/">phpBB.com/mods/umil</a>', E_USER_ERROR);
}

// The name of the mod to be displayed during installation.
$mod_name = 'RATINGS_MOD';

/*
* The name of the config variable which will hold the currently installed version
* UMIL will handle checking, setting, and updating the version itself.
*/
$version_config_name = 'phpbbex_posts_rating_version';

// The language file which will be included when installing
$language_file = 'mods/info_acp_rate';

/*
* Optionally we may specify our own logo image to show in the upper corner instead of the default logo.
* $phpbb_root_path will get prepended to the path specified
* Image height should be 50px to prevent cut-off or stretching.
*/
// $logo_img = 'styles/prosilver/imageset/site_logo.gif';

/*
* The array of versions and actions within each.
* You do not need to order it a specific way (it will be sorted automatically), however, you must enter every version, even if no actions are done for it.
*
* You must use correct version numbering.  Unless you know exactly what you can use, only use X.X.X (replacing X with an integer).
* The version numbering must otherwise be compatible with the version_compare function - http://php.net/manual/en/function.version-compare.php
*/
$versions = array(
	'1.0.0' => array(
		'config_add' => array(
			array('rate_enabled', '1', 0),
			array('rate_only_topics', '0', 0),
			array('rate_time', '0', 0),
			array('rate_topic_time', '-1', 0),
			array('rate_change_time', '300', 0),
			array('rate_no_negative', '0', 0),
			array('rate_no_positive', '0', 0),
			array('style_mp_show_rating', '1', 0),
			array('style_mp_show_rating_detailed', '0', 0),
			array('style_mp_show_rated', '0', 0),
			array('style_mp_show_rated_detailed', '0', 0),
			array('style_p_show_rating', '1', 0),
			array('style_p_show_rating_detailed', '1', 0),
			array('style_p_show_rated', '0', 0),
			array('style_p_show_rated_detailed', '0', 0),
			array('style_ml_show_rating', '1', 0),
			array('style_ml_show_rating_detailed', '0', 0),
			array('style_ml_show_rated', '0', 0),
			array('style_ml_show_rated_detailed', '0', 0),
		),

		'table_add' => array(
			array('phpbb_post_rates', array(
					'COLUMNS'		=> array(
						'user_id'	=> array('UINT', NULL),
						'post_id'	=> array('UINT', NULL),
						'rate'		=> array('TINT:4', 0),
						'rate_time'	=> array('TIMESTAMP', 0),
					),

					'PRIMARY_KEY'	=> array('user_id', 'post_id'),

					'KEYS'		=> array(
						'post_id'	=> array('INDEX',	'post_id'),
						'user_id'	=> array('INDEX',	'user_id'),
					),
				),
			),
		),

		'table_column_add' => array(
			array('phpbb_posts', 'post_rating_positive', array('UINT', '0')),
			array('phpbb_posts', 'post_rating_negative', array('UINT', '0')),
			array('phpbb_users', 'user_rating_positive', array('UINT', '0')),
			array('phpbb_users', 'user_rating_negative', array('UINT', '0')),
			array('phpbb_users', 'user_rated_positive', array('UINT', '0')),
			array('phpbb_users', 'user_rated_negative', array('UINT', '0')),
		),

		'permission_add' => array(
			array('u_canplus', 1),
			array('u_canminus', 1),
		),

		'module_add' => array(
			array('acp', 'ACP_CAT_DOT_MODS', 'RATINGS_MOD'),
			array('acp', 'RATINGS_MOD', array(
					'module_basename'	=> 'rate',
					'module_langname'	=> 'SETTINGS',
					'module_mode'		=> 'settings',
					'module_auth'		=> 'acl_a_board',
				),
			),
		),
	),
);

// Include the UMIL Auto file, it handles the rest
include($phpbb_root_path . 'umil/umil_auto.' . $phpEx);

?>